//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%39F89FB20273.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%39F89FB20273.cm

//## begin module%39F89FB20273.cp preserve=no
//## end module%39F89FB20273.cp

//## Module: ResponseContainer%39F89FB20273; Package body
//## Subsystem: XSModel::GlobalContainer%3E4293160205
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/GlobalContainer/ResponseContainer.cxx

//## begin module%39F89FB20273.additionalIncludes preserve=no
//## end module%39F89FB20273.additionalIncludes

//## begin module%39F89FB20273.includes preserve=yes
#include <sstream>
//## end module%39F89FB20273.includes

// DummyResponse
#include <XSModel/Data/Detector/DummyResponse.h>
// XSutility
#include <XSUtil/Utils/XSutility.h>
// ResponseContainer
#include <XSModel/GlobalContainer/ResponseContainer.h>


//## begin module%39F89FB20273.declarations preserve=no
//## end module%39F89FB20273.declarations

//## begin module%39F89FB20273.additionalDeclarations preserve=yes
#include <XSModel/Data/Detector/MultiResponse.h>
#include <XSModel/Data/Detector/RealResponse.h>
#include <XSModel/Data/Detector/UserDummyResponse.h>
#include <XSModel/Parameter/ParameterLink.h>
#include <XSModel/Parameter/ResponseParam.h>
#include <XSUtil/Utils/XSstream.h>
#include <XSstreams.h>
#include <XSContainer.h>
#include <XSsymbol.h>
#include <iomanip>
#include <iostream>
//## end module%39F89FB20273.additionalDeclarations


//## Modelname: XSModel::GlobalContainer%3E42929A0210
namespace XSContainer {
    //## begin XSContainer%3E42929A0210.initialDeclarations preserve=yes
     ResponseContainer* responses = 0;
    //## end XSContainer%3E42929A0210.initialDeclarations

    // Class XSContainer::ResponseContainer 

    //## begin XSContainer::ResponseContainer::instance%376A5F0561A8.attr preserve=no  private: static ResponseContainer* {U} 0
    ResponseContainer* ResponseContainer::s_instance = 0;
    //## end XSContainer::ResponseContainer::instance%376A5F0561A8.attr

    ResponseContainer::ResponseContainer (DummyResponse* dummy)
      //## begin XSContainer::ResponseContainer::ResponseContainer%3E9C2D190182.hasinit preserve=no
      //## end XSContainer::ResponseContainer::ResponseContainer%3E9C2D190182.hasinit
      //## begin XSContainer::ResponseContainer::ResponseContainer%3E9C2D190182.initialization preserve=yes
       :m_respParContainer(1),
       m_respParIndexOffsets(1),
       m_totalResponseParams(0)
      //## end XSContainer::ResponseContainer::ResponseContainer%3E9C2D190182.initialization
    {
      //## begin XSContainer::ResponseContainer::ResponseContainer%3E9C2D190182.body preserve=yes
      m_responseList.insert(ResponseMap::value_type(DUMMY_RSP,dummy));

      XSstream& xscout = static_cast<XSstream&>(tcout);
      if (std::min(xscout.consoleChatterLevel(),xscout.logChatterLevel()) > 25)
      { 
            tcout << "ResponseContainer Initialization:  eMin: " << dummy->eLow() << " eMax: " 
                            << dummy->eHigh() <<  " nE: " << dummy->numEnergies() 
                            << " ln: ? " << std::boolalpha << dummy->isLog() << std::endl;
      }
      //## end XSContainer::ResponseContainer::ResponseContainer%3E9C2D190182.body
    }


    ResponseContainer::~ResponseContainer()
    {
      //## begin XSContainer::ResponseContainer::~ResponseContainer%376A5DA5E608_dest.body preserve=yes
      //## end XSContainer::ResponseContainer::~ResponseContainer%376A5DA5E608_dest.body
    }



    //## Other Operations (implementation)
    ResponseContainer* ResponseContainer::Instance (DummyResponse* dummy)
    {
      if (s_instance == 0) {s_instance = new ResponseContainer(dummy);} return s_instance;


      //## begin XSContainer::ResponseContainer::Instance%376A5F063B58.body preserve=yes
      //## end XSContainer::ResponseContainer::Instance%376A5F063B58.body
    }

    void ResponseContainer::addToList (const string& name, Response* newResponse)
    {
      //## begin XSContainer::ResponseContainer::addToList%39ECBCF6024F.body preserve=yes
  
          // supplying a released auto_ptr would be a better way perhaps.

          responseList(name,newResponse); 
        
      //## end XSContainer::ResponseContainer::addToList%39ECBCF6024F.body
    }

    void ResponseContainer::addToList (const RefCountPtr<RMF>& newRMF)
    {
      //## begin XSContainer::ResponseContainer::addToList%3A9D615702AD.body preserve=yes
        RMFmap(newRMF->name(), RefCountPtr<RMF>(newRMF));
      //## end XSContainer::ResponseContainer::addToList%3A9D615702AD.body
    }

    const Response* ResponseContainer::responseList (const string& name, size_t index) const
    {
      //## begin XSContainer::ResponseContainer::responseList%3ABB685D031B.body preserve=yes
        return internalFind(name,index);      
      //## end XSContainer::ResponseContainer::responseList%3ABB685D031B.body
    }

    Response* ResponseContainer::responseList (const string& name, size_t index)
    {
      //## begin XSContainer::ResponseContainer::responseList%3ABB688400BB.body preserve=yes
        return internalFind(name,index);
      //## end XSContainer::ResponseContainer::responseList%3ABB688400BB.body
    }

    void ResponseContainer::responseList (const string& name, Response* value)
    {
      //## begin XSContainer::ResponseContainer::responseList%3ABB697502A8.body preserve=yes
        m_responseList.insert(ResponseMap::value_type(name,value));
      //## end XSContainer::ResponseContainer::responseList%3ABB697502A8.body
    }

    void ResponseContainer::RMFmap (const string& name, const RefCountPtr<RMF>& rmf)
    {
      //## begin XSContainer::ResponseContainer::RMFmap%3ABB7E70005E.body preserve=yes
        m_RMFmap.insert(RMFMap::value_type(name,rmf));
      //## end XSContainer::ResponseContainer::RMFmap%3ABB7E70005E.body
    }

    size_t ResponseContainer::numberOfResponses () const
    {
      //## begin XSContainer::ResponseContainer::numberOfResponses%3ABBCB990097.body preserve=yes
      //## end XSContainer::ResponseContainer::numberOfResponses%3ABBCB990097.body

      return m_responseList.size();
    }

    void ResponseContainer::removeByToken (const std::vector<Response*>& doomed, size_t sourceNum)
    {
      //## begin XSContainer::ResponseContainer::removeByToken%3AC217B603CD.body preserve=yes
        size_t n(doomed.size());
        
	// If sourceNum is 0 (default), remove all responses in the vector,
	// else just remove that specified by sourceNum.
        for (size_t j = (sourceNum==0 ? 0 : sourceNum-1); j < n; ++j)
        {                
           ResponseMapIter d(m_responseList.begin());
	   ResponseMapIter dEnd(m_responseList.end());
           while (d != dEnd)
           {
              Response* current(d->second);
              if (current == doomed[j]) 
              {
                 // No longer calling delete on current.  The SpectralData
                 // obj and NOT ResponseContainer will now be responsible
                 // for Response memory (Jan 06).
                 
                 //remove from list of RMFs.
                 m_responseList.erase(d);
                 // Also delete any response params it may have.  We don't
                 // want these hanging around in the TrashCan.  (Undo will
                 // restore them by calling the gain command anew.) This
                 // also causes response params to be removed from the
                 // global list.
                 current->removeGain();
                 break;       
              } 
              else ++d;
           }
	   if (sourceNum != 0) break;
        }

      //## end XSContainer::ResponseContainer::removeByToken%3AC217B603CD.body
    }

    void ResponseContainer::removeByToken (const RefCountPtr<RMF>& doomed) throw ()
    {
      //## begin XSContainer::ResponseContainer::removeByToken%3ACB287D0018.body preserve=yes

          // associative container erase functions are guaranteed  by
          // the standard not to throw.   This function will be called by
          // RealResponse's dtor.   
          RMFMapIter m(m_RMFmap.begin());
          RMFMapIter mEnd(m_RMFmap.end());
          while ( m != mEnd )
          {
                  RefCountPtr<RMF>& current( (*m).second);
	          if ( *current == *doomed )
	          {
                          m_RMFmap.erase(m);
                          break;
	          }	
	          else ++m;
          }
      //## end XSContainer::ResponseContainer::removeByToken%3ACB287D0018.body
    }

    Response* ResponseContainer::internalFind (const string& name, size_t index) const
    {
      //## begin XSContainer::ResponseContainer::internalFind%3BAF7BAD0093.body preserve=yes
          size_t N = m_responseList.count(name);

          if (N == 0) return 0;
          else 
          {
                ResponseMapConstIter f = m_responseList.lower_bound(name);       
                if (N == 1)
                {
                        return (*f).second;
                }      
                else
                {
                        ResponseMapConstIter g = m_responseList.upper_bound(name);
                        while ( f != g)
                        {
                                if ( ((*f).second)->index()  != index )
				{
				    ++f;
				}
				else
				{
                                   return (*f).second; 
				}
                        }
                        return 0;
                }

          }      
      //## end XSContainer::ResponseContainer::internalFind%3BAF7BAD0093.body
    }

    Response* ResponseContainer::swapResponses (Response* inResponse, Response* outResponse)
    {
      //## begin XSContainer::ResponseContainer::swapResponses%3E70B2A0000B.body preserve=yes
      ResponseMapIter itResp(m_responseList.begin());
      ResponseMapIter itRespEnd(m_responseList.end());
      bool isFound = false;
      while (itResp != itRespEnd)
      {
         if (itResp->second == outResponse)
	 {
            // Must reconstruct the global map name key for the inReponse:
            string nameKey;
            if (const RealResponse* rr = inResponse->toRealResponse())
               nameKey = rr->rmfName();
            else if (inResponse->toUserDummyResponse())
               nameKey = USR_DUMMY_RSP;
            else if (const MultiResponse* mr = inResponse->toMultiResponse())
            {
               for (size_t i=0; i<mr->rmfNames().size(); ++i)
                  nameKey += mr->rmfNames()[i] + " ";
            }
         
            m_responseList.insert(ResponseMap::value_type(nameKey,inResponse));
            m_responseList.erase(itResp);
         
            outResponse->deregisterResponseParams();
            inResponse->registerResponseParams();
            
	    isFound = true;
	    break;
	 }
	 ++itResp;
      }
      return isFound ? outResponse : static_cast<Response*>(0);
      //## end XSContainer::ResponseContainer::swapResponses%3E70B2A0000B.body
    }

    void ResponseContainer::clearGainParameters ()
    {
      //## begin XSContainer::ResponseContainer::clearGainParameters%414A047200CA.body preserve=yes
     
      // Intended to remove all gain pointers from respParContainer AND 
      // destroy the gain parameters themselves.
      
      // For future implementations, ASSUME that not every pointer is a
      // gain pointer (even if that's the case for now).  
      
      // This algorithm can result in redundant calls to a particular 
      // Response's removeGainParams function, but if we assume that only 
      // a small subset of Responses have ResponseParams then this is 
      // quicker than stepping directly through the list of all stored Responses.
      // (This could most benefit from keeping a container which stores only
      // those Responses containing parameters, but it doesn't seem worth
      // the additional bookkeeping overhead.)
              
      if (m_totalResponseParams)
      {
         for (size_t i=0; i<m_respParContainer.size(); ++i)
         {
            std::vector<ResponseParam*>& parsForSource = m_respParContainer[i];
            size_t j=0;
            while (parsForSource.size() && j < parsForSource.size())
            {
               Response* resp = parsForSource[j]->responseParent();
               if (resp->getConstGain())
               {
                  // This reduces the size of parsForSource by 2, and
                  // j will now point to a different parameter (if any)
                  resp->removeGainParams();
               }
               else
                  ++j;
            }
         }
      }
      
      //## end XSContainer::ResponseContainer::clearGainParameters%414A047200CA.body
    }

    void ResponseContainer::rerouteBrokenParLinks (std::set<Parameter*>& doomedPars) const
    {
      //## begin XSContainer::ResponseContainer::rerouteBrokenParLinks%49C2984A0189.body preserve=yes
      
       // ASSUME all params in respParContainer are persistent, so there should
       // be no overlap between doomedPars and respParContainer pointers.
       
       // The isModelDoomed flag is checked by findPersistentLink, and was
       // originally named as such for dealing with ModParams.  isParDoomed
       // would be a more accurate description.
       std::set<Parameter*>::iterator itPar = doomedPars.begin();
       std::set<Parameter*>::iterator itEnd = doomedPars.end();
       while (itPar != itEnd)
       {
          (*itPar)->isModelDoomed(true);
          ++itPar;
       }
       
       std::map<Parameter*,Parameter*> processedDoomedPars;
       while (!doomedPars.empty())
       {
          Parameter::findPersistentLink(*doomedPars.begin(),doomedPars,
                        processedDoomedPars);
       }
       
       for (size_t iSource=0; iSource<m_respParContainer.size(); ++iSource)
       {
          const std::vector<ResponseParam*>& parsForSource = m_respParContainer[iSource];
          for (size_t i=0; i<parsForSource.size(); ++i)
          {
             ResponseParam* respPar = parsForSource[i];
             if (respPar->isLinked())
             {
                std::vector<Parameter*> correctedToPars;
                bool correctionMade = false;
                bool removeLink = false;
                const std::vector<const Parameter*>& toPars = respPar->thisLink()->members();
                for (size_t j=0; !removeLink && j<toPars.size(); ++j)
                {
                   Parameter* toPar = const_cast<Parameter*>(toPars[j]);
                   if (toPar->isModelDoomed())
                   {
                      Parameter* reRouted = processedDoomedPars.find(toPar)->second;
                      if (!reRouted)
                      {
                         removeLink = true;
                         respPar->untie(true);
                      }
                      else
                      {
                         correctedToPars.push_back(reRouted);
                         correctionMade = true;
                      }
                   }
                   else
                   {
                      correctedToPars.push_back(toPar);
                   }
                }
                if (!removeLink && correctionMade)
                   respPar->thisLink()->rerouteLink(correctedToPars);
             } // end if linked
          } // end parsForSource loop
       } // end source loop
       
      //## end XSContainer::ResponseContainer::rerouteBrokenParLinks%49C2984A0189.body
    }

    void ResponseContainer::adjustNumSources (size_t nSources)
    {
      //## begin XSContainer::ResponseContainer::adjustNumSources%49E4EFBA0237.body preserve=yes
       // Since this can only remove entire batch of parameters associated
       // with a source, no reindexing is ever required.
       m_respParContainer.resize(nSources);
       m_respParIndexOffsets.resize(nSources);
      //## end XSContainer::ResponseContainer::adjustNumSources%49E4EFBA0237.body
    }

    void ResponseContainer::reindexResponseParams (size_t sourceNum, size_t specNum, size_t iRespStart, int nChanged)
    {
      //## begin XSContainer::ResponseContainer::reindexResponseParams%49E646B30033.body preserve=yes
      
       // Actually do 2 things here: reindex all affected response params, and
       // reset the values in the offsets map.
       
       // KEY ASSUMPTION: nChanged ResponseParam pointers belonging to the Response
       // at sourceNum:specNum have just been inserted or removed from respPar
       // container.  
       
       const bool isRemoval = nChanged < 0; 
       IndexOffsetMap& offsetsForSource = m_respParIndexOffsets[sourceNum-1];
       IndexOffsetMap::iterator itOffset = offsetsForSource.find(specNum);
       IndexOffsetMap::iterator itEnd = offsetsForSource.end();
       if (itOffset == itEnd)
       {
          itOffset = offsetsForSource.insert(std::make_pair(specNum,iRespStart)).first;
       }
          
       // itOffset must be pointing to the entry for the affected spectrum.
       
       const size_t unNChanged = isRemoval ?  static_cast<size_t>(-1*nChanged) 
                                        : static_cast<size_t>(nChanged); 
       if (isRemoval)
       {
          // If the spectrum is losing all its parameters for this response,
          // then take it out of the map.
          IndexOffsetMap::iterator itNextSpec(itOffset);
          ++itNextSpec;
          if (itNextSpec == itEnd)
          {
             if (m_respParContainer[sourceNum-1].size() == itOffset->second)
                offsetsForSource.erase(itOffset);
          }
          else if ((itNextSpec->second - itOffset->second) == unNChanged)
          {
             offsetsForSource.erase(itOffset);
          }
          
          while (itNextSpec != itEnd)
          {
             itNextSpec->second -= unNChanged;
             ++itNextSpec;
          }
       }
       else
       {
          ++itOffset;
          while (itOffset != itEnd)
          {
             itOffset->second += unNChanged;
             ++itOffset;
          }
       }
       
       // Now comes the actual reindexing, which is the easy part.
       
       std::vector<ResponseParam*>& respPars = m_respParContainer[sourceNum-1];
       const size_t nPars = respPars.size();
       for (size_t i=iRespStart; i<nPars; ++i)
          respPars[i]->index(i+1);
       
      //## end XSContainer::ResponseContainer::reindexResponseParams%49E646B30033.body
    }

    void ResponseContainer::addToRespParContainer (const Response* resp, size_t startIdx, const std::vector<ResponseParam*>& respParams)
    {
      //## begin XSContainer::ResponseContainer::addToRespParContainer%49E78FCD009D.body preserve=yes
       const size_t sourceNum = resp->sourceNumber();
       const size_t specNum = resp->spectrumNumber();
       std::vector<ResponseParam*>& parsForSource = m_respParContainer[sourceNum-1];
       const IndexOffsetMap& offsetsForSource = m_respParIndexOffsets[sourceNum-1];
       
       // Find the current starting location in the global vector for this 
       // Response's params. If not found in the index offset map, it takes 
       // the offset from the next spectrum or is placed at the end of the vector.
       size_t iRespStart=0;
       IndexOffsetMap::const_iterator itOffsets = offsetsForSource.find(specNum);
       IndexOffsetMap::const_iterator itEnd = offsetsForSource.end();
       if (itOffsets == itEnd)
       {
          IndexOffsetMap::const_iterator itNextSpec = 
                        offsetsForSource.upper_bound(specNum);
          if (itNextSpec == itEnd)
             iRespStart = parsForSource.size();
          else
             iRespStart = itNextSpec->second;
       }
       else
          iRespStart = itOffsets->second; 
          
       if (iRespStart + startIdx > parsForSource.size())
          throw RedAlert("Response parameter insert indexing error.\n");   
          
       // While vectors aren't very efficient for inserting/erasing in 
       // the middle, I decided to do it this way anyhow because the 
       // random-access is useful in other contexts, and because the 
       // reindexing which follows is still bound by O(N). In fact
       // if this were a map, the reindexing would be O(NlogN).    
       
       parsForSource.insert(parsForSource.begin()+iRespStart+startIdx,
                respParams.begin(), respParams.end());
       m_totalResponseParams += respParams.size();         
       reindexResponseParams(sourceNum,specNum,iRespStart,respParams.size());
       
      //## end XSContainer::ResponseContainer::addToRespParContainer%49E78FCD009D.body
    }

    void ResponseContainer::removeFromRespParContainer (const Response* resp, size_t startIdx, size_t nPars)
    {
      //## begin XSContainer::ResponseContainer::removeFromRespParContainer%49E792DC0240.body preserve=yes
       const size_t sourceNum = resp->sourceNumber();
       const size_t specNum = resp->spectrumNumber();
       std::vector<ResponseParam*>& parsForSource = m_respParContainer[sourceNum-1];
       const IndexOffsetMap& offsetsForSource = m_respParIndexOffsets[sourceNum-1];
       
       // Find the current starting location in the global vector for this 
       // Response's params. If not found in the index offset map, throw.
       size_t iRespStart=0;
       IndexOffsetMap::const_iterator itOffsets = offsetsForSource.find(specNum);
       IndexOffsetMap::const_iterator itEnd = offsetsForSource.end();
       if (itOffsets == itEnd)
       {
          throw RedAlert("Response parameter indexing failure: missing spectrum\n");
       }
       else
          iRespStart = itOffsets->second; 
          
       if (iRespStart + startIdx + nPars > parsForSource.size())
          throw RedAlert("Response parameter erase indexing error.\n");   
       
       // Store doomed pars in a set which is needed by Parameter's
       // findPersistentLink function.
       std::set<Parameter*> doomedPars;
       const size_t beginDoomed = iRespStart+startIdx;
       const size_t endDoomed = beginDoomed+nPars;
       for (size_t i=beginDoomed; i<endDoomed; ++i)
          doomedPars.insert(parsForSource[i]);
       
       // This must be called PRIOR to the rerouteBrokenParLinks function,
       // as that assumes all pointers in RespParContainer are persistent.     
       parsForSource.erase(parsForSource.begin()+beginDoomed,
                parsForSource.begin()+endDoomed);
       m_totalResponseParams -= nPars;
       rerouteBrokenParLinks(doomedPars);
                
       reindexResponseParams(sourceNum,specNum,iRespStart,-1*static_cast<int>(nPars));
       
      //## end XSContainer::ResponseContainer::removeFromRespParContainer%49E792DC0240.body
    }

    void ResponseContainer::reportResponseParams () const
    {
      //## begin XSContainer::ResponseContainer::reportResponseParams%49FB131D0276.body preserve=yes
       const size_t linelen(72);
       const string top(linelen,'=');
       const string bot(linelen,'_');
       for (size_t iSource=0; iSource<m_respParContainer.size(); ++iSource)
       {
          const std::vector<ResponseParam*>& respParsForSource = 
                        m_respParContainer[iSource];
          const size_t nPars = respParsForSource.size();
          if (nPars)
          {
             tcout << '\n' << top
                << "\nSource No.: " << iSource+1
                << "\nRpar Spectrum Rmodel   Rpar_name  Unit   Value\n" 
                << std::endl;
             for (size_t iPar=0; iPar<nPars; ++iPar)
             {
                tcout << *respParsForSource[iPar];
             }
             tcout << bot << std::endl;
          }
       }
       tcout << std::endl;
      //## end XSContainer::ResponseContainer::reportResponseParams%49FB131D0276.body
    }

    void ResponseContainer::renumberSpectrum (const size_t start, const size_t offset)
    {
      //## begin XSContainer::ResponseContainer::renumberSpectrum%4A0DD58C01FB.body preserve=yes
       // start is 1-based.  The spectrum which had this number and whose
       // removal is the reason for this call, must have been removed from
       // the IndexOffsetMap BEFORE getting here.
       if (start < offset)
          throw RedAlert("Invalid spectrum offset sent to ResponseContainer::renumberSpectrum.");
          
       for (size_t iSource=0; iSource<m_respParIndexOffsets.size(); ++iSource)
       {
          IndexOffsetMap& parsForSource = m_respParIndexOffsets[iSource];
          IndexOffsetMap::iterator itEnd = parsForSource.end();
          IndexOffsetMap::iterator itSpec = parsForSource.lower_bound(start);
          // itSpec ought to point to the lowest spec num higher than start.
          if (itSpec != itEnd && itSpec->first == start)
             throw RedAlert("Spectrum number error in ResponseContainer::renumberSpectrum.");
          while (itSpec != itEnd)
          {
             // Lower every key larger than start by offset.  Do this by
             // erasing the old key then inserting the new key.  For a
             // reminder regarding iterator validity, see 23.1.2.8 in the
             // '98 standard.
             size_t oldNum = itSpec->first;
             size_t newNum = oldNum - offset;
             std::pair<size_t,size_t> updatedEntry(newNum,itSpec->second);             
             parsForSource.erase(itSpec++);
             parsForSource.insert(updatedEntry);
          }
       }
      //## end XSContainer::ResponseContainer::renumberSpectrum%4A0DD58C01FB.body
    }

    //## Get and Set Operations for Associations (implementation)

    ResponseMap& ResponseContainer::responseList ()
    {
      //## begin XSContainer::ResponseContainer::responseList%3ABA77BE019D.get preserve=no
      return m_responseList;
      //## end XSContainer::ResponseContainer::responseList%3ABA77BE019D.get
    }

    // Additional Declarations
      //## begin XSContainer::ResponseContainer%376A5DA5E608.declarations preserve=yes
      //## end XSContainer::ResponseContainer%376A5DA5E608.declarations

} // namespace XSContainer

//## begin module%39F89FB20273.epilog preserve=yes
//## end module%39F89FB20273.epilog
